package Fractal2D.Math;

public class TestArithmetics {
	public float[] buffer;
	public float size = 1024.0f;

	public TestArithmetics(TestArithmetics a) {
		buffer = new float[a.buffer.length];
		for (int i = 0; i < buffer.length; i++)
			buffer[i] = a.buffer[i];
	}

	public TestArithmetics(int length) {
		buffer = new float[length];
	}

	public TestArithmetics(double number, int length) {
		buffer = new float[length];
		// signum=(float)Math.signum(number);
		// number=Math.abs(number);
		if (number >= 0) {
			double dInt = Math.floor(number);
			buffer[0] = (float) dInt;
			for (int i = 1; i < length; i++) {
				number -= dInt;
				number *= size;
				dInt = Math.floor(number);
				buffer[i] = (float) dInt;
			}
		} else {
			double dInt = Math.ceil(number);
			buffer[0] = (float) dInt;
			for (int i = 1; i < length; i++) {
				number -= dInt;
				number *= size;
				dInt = Math.ceil(number);
				buffer[i] = (float) dInt;
			}
		}

	}

	public TestArithmetics(float number, int length) {
		buffer = new float[length];
		// signum=(float)Math.signum(number);
		// number=Math.abs(number);
		if (number >= 0) {
			double dInt = Math.floor(number);
			buffer[0] = (float) dInt;
			for (int i = 1; i < length; i++) {
				number -= dInt;
				number *= size;
				dInt = Math.floor(number);
				buffer[i] = (float) dInt;
			}
		} else {
			double dInt = Math.ceil(number);
			buffer[0] = (float) dInt;
			for (int i = 1; i < length; i++) {
				number -= dInt;
				number *= size;
				dInt = Math.ceil(number);
				buffer[i] = (float) dInt;
			}
		}

	}

	public TestArithmetics clone() {
		TestArithmetics a = new TestArithmetics(this.buffer.length);
		for (int i = 0; i < this.buffer.length; i++)
			a.buffer[i] = this.buffer[i];
		// a.signum=this.signum;
		return a;
	}

	public double convertToDouble() {
		double number = 0;
		// double factor=1.0;
		// number=buffer[0]*factor;
		for (int i = buffer.length - 1; i > 0; i--) {
			number += buffer[i];
			number /= size;
		}
		number += buffer[0];
		// if(signum==-1)number=-number;
		return number;
	}

	public TestArithmetics chgSign() {
		TestArithmetics a = new TestArithmetics(buffer.length);
		for (int i = 0; i < this.buffer.length; i++) {
			a.buffer[i] = -this.buffer[i];
		}
		// a.signum=-this.signum;
		return a;
	}

	public boolean isLessThanEqualZero() {
		for (int i = 0; i < buffer.length; i++) {
			if (buffer[i] > 0.0f)
				return false;
		}
		return true;
	}

	public void add(TestArithmetics a) {
		for (int i = 0; i < buffer.length; i++) {
			buffer[i] += a.buffer[i];

		}
		buffer[0] -= 2.0f;
		buffer[buffer.length - 1] += 2*size;
		for (int i = 1; i < buffer.length - 1; i++) {
			buffer[i] += 2*size-2f;
		}
		for (int j = buffer.length - 1; j > 0; j--) {
			if (buffer[j] >= size) {
				float temp = (float) Math.floor(Math.abs(buffer[j]) / size);
				buffer[j] -= temp * size;
				buffer[j - 1] += temp;
			}
		}

	}

	public void add2(TestArithmetics a) {
		for (int i = 0; i < buffer.length; i++) {
			buffer[i] += a.buffer[i];

		}
		buffer[0] -= 2.0f;
		buffer[buffer.length - 1] -= 2*size;
		for (int i = 1; i < buffer.length - 1; i++) {
			buffer[i] -= 2*size-2f;
		}
		for (int j = buffer.length - 1; j > 0; j--) {
			if (buffer[j] >= size) {
				float temp = (float) Math.ceil(Math.abs(buffer[j]) / size);
				buffer[j] -= temp * size;
				buffer[j - 1] += temp;
			}
		}

	}

	public void div(float a) {
		float temp = buffer[0];
		// float sign=Math.signum((float)(temp/a));
		buffer[0] /= a;
		buffer[0] = (buffer[0] >= 0.0f) ? (float) Math.floor(buffer[0])
				: (float) Math.ceil(buffer[0]);
		float rest = (float) (temp - buffer[0] * a);
		for (int i = 1; i < buffer.length; i++) {
			buffer[i] += size * rest;
			temp = buffer[i];
			buffer[i] /= a;
			buffer[i] = (buffer[i] >= 0.0f) ? (float) Math.floor(buffer[i])
					: (float) Math.ceil(buffer[i]);
			rest = (float) (temp - buffer[i] * a);

		}
	}

	public void div(double a) {
		float temp = buffer[0];
		// float sign=Math.signum((float)(temp/a));
		buffer[0] /= a;
		buffer[0] = (buffer[0] >= 0.0f) ? (float) Math.floor(buffer[0])
				: (float) Math.ceil(buffer[0]);
		float rest = (float) (temp - buffer[0] * a);
		for (int i = 1; i < buffer.length; i++) {
			buffer[i] += size * rest;
			temp = buffer[i];
			buffer[i] /= a;
			buffer[i] = (buffer[i] >= 0.0f) ? (float) Math.floor(buffer[i])
					: (float) Math.ceil(buffer[i]);
			rest = (float) (temp - buffer[i] * a);

		}
	}

	public void mult(TestArithmetics a) {
		TestArithmetics[] aTestArithmetics = new TestArithmetics[a.buffer.length];
		for (int i = 0; i < aTestArithmetics.length; i++) {
			aTestArithmetics[i] = new TestArithmetics(buffer.length);
			aTestArithmetics[i].buffer[0] = buffer[0] * a.buffer[i];
			for (int j = 1; j < buffer.length; j++) {
				aTestArithmetics[i].buffer[j] = buffer[j] * a.buffer[i];

			}
		}

		float[] tempBuffer = new float[buffer.length + aTestArithmetics.length
				- 1];

		for (int i = tempBuffer.length - buffer.length; i < tempBuffer.length; i++) {
			tempBuffer[i] = aTestArithmetics[aTestArithmetics.length - 1].buffer[i
					- (tempBuffer.length - buffer.length)];
		}
		for (int i = aTestArithmetics.length - 2; i > 0; i--) {
			for (int j = a.buffer.length - 1; j >= 0; j--) {
				tempBuffer[i + j] += aTestArithmetics[i].buffer[j];
				if (Math.abs(tempBuffer[i + j]) >= size) {
					float signum = Math.signum(tempBuffer[i + j]);
					float temp = (float) Math.floor(Math.abs(tempBuffer[i + j])
							/ size);
					tempBuffer[i + j] -= temp * size * signum;
					tempBuffer[i + j - 1] += temp * signum;
				}
			}

		}
		for (int j = a.buffer.length - 1; j > 0; j--) {
			tempBuffer[j] += aTestArithmetics[0].buffer[j];
			if (Math.abs(tempBuffer[j]) >= size) {
				float signum = Math.signum(tempBuffer[j]);
				float temp = (float) Math.floor(Math.abs(tempBuffer[j]) / size);
				tempBuffer[j] -= temp * size * signum;
				tempBuffer[j - 1] += temp * signum;
			}
		}
		tempBuffer[0] += aTestArithmetics[0].buffer[0];
		for (int i = 0; i < this.buffer.length; i++) {
			this.buffer[i] = tempBuffer[i];
		}
		// System.out.println(x);
	}

	public void compress(TestArithmetics a) {
		for (int i = 0; i < buffer.length; i++) {
			this.buffer[i] = Math.abs(buffer[i])
					- (float) Math.ceil((Math.signum(buffer[i]) - 1) * 0.5f)
					* size + Math.abs(a.buffer[i]) * size * 2
					- (float) Math.ceil((Math.signum(a.buffer[i]) - 1) * 0.5f)
					* size * size * 2;
		}
	}

	public TestArithmetics decompress() {
		TestArithmetics a = new TestArithmetics(buffer.length);
		for (int i = 0; i < buffer.length; i++) {
			float sign = (float) Math.floor(buffer[i] / (size * size * 2));
			buffer[i] -= sign * size * size * 2;
			sign = -(sign - 0.5f) * 2;
			a.buffer[i] = (float) Math.floor(buffer[i] / (size * 2));
			buffer[i] -= a.buffer[i] * size * 2;
			a.buffer[i] *= sign;
			sign = (float) Math.floor(buffer[i] / (size));
			buffer[i] -= sign * size;
			sign = -(sign - 0.5f) * 2;
			buffer[i] *= sign;
		}
		return a;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		double zahl6 = 5;
		double zahl7 = -3;
		System.out.println("div:" + (zahl6 / zahl7));
		System.out.println((new TestArithmetics(zahl6 / zahl7, 8))
				.convertToDouble());
		TestArithmetics c = new TestArithmetics(zahl6, 20);
		c.div(zahl7);
		System.out.println(c.convertToDouble());
		/*
		 * for(int i=0;i<c.buffer.length;i++){
		 * System.out.println("t: "+c.buffer[i]); }
		 */
		double z1 = -3.98;
		double z2 = 4.0;
		System.out.println(z1);
		System.out.println(z2);
		TestArithmetics a = new TestArithmetics(z1, 8);
		TestArithmetics b = new TestArithmetics(z2, 8);
		System.out.println(a.convertToDouble());
		System.out.println(b.convertToDouble());
		System.out.println("doubleAdd: " + (z1 + z2));

		a.add(b);
		for (int i = 0; i < a.buffer.length; i++) {
			System.out.println("t: " + a.buffer[i]);
		}
		System.out.println("fixAdd: " + a.convertToDouble());
		System.out.println("test: " + (a.convertToDouble() < 0));
		System.out.println("double: " + z1 * z2);
		a = new TestArithmetics(z1, 8);
		b = new TestArithmetics(z2, 8);
		a.mult(b);
		System.out.println("ta:     " + a.convertToDouble());
		for (int i = 0; i < a.buffer.length; i++) {
			System.out.println("t: " + a.buffer[i]);
		}

		float myTest = -0.9999f;
		System.out.println((Math.floor(myTest)));
		TestArithmetics compress1 = new TestArithmetics(-9.999999, 8);
		TestArithmetics compress2 = new TestArithmetics(-9.9994322, 8);
		compress1.compress(compress2);
		compress2 = compress1.decompress();
		System.out.println(compress1.convertToDouble());
		System.out.println(compress2.convertToDouble());

	}

}
